// entry point of the program

let area = Util.circle_area(45.0);
print_endline(string_of_float(area));

let p1 = (3, 2);
let p2 = (5, 7);

let (x, y) = Util.add_points_decompose(p1, p2);
Printf.printf("(%d, %d)\n", x, y);

type tree('a) =
    | Empty
    | Node('a, tree('a), tree('a));

let example_tree = Node( "a",
    Node("b",
        Node("d", Empty, Empty),
        Node("e",Empty, Empty)
    ),
    Node("c", Empty, Node("f", Empty, Empty))
);

// in-order traversal: recurse-left, print self, recurse-right
let rec inorder = (t: tree(string)) => {
    switch (t) {
    | Empty => print_endline("");
    | Node(v, left, right) => {
        inorder(left);
        print_endline(v);
        inorder(right);
    }
    };
}

inorder(example_tree);

let apply_twice = (f: 'a => 'a, a: 'a) => {
    f(f(a));
}

// formula for a line y = m*x + b
let line = (m, b) => {
    (x) => {
        m *. x +. b
    };
}

let line1 = line(3., 6.);
Printf.printf("%f\n", line1(0.));
Printf.printf("%f\n", line1(2.));

let line2 = line(-3.5, -3.4);

let slope2 = line(2.);


